unit Main;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, Menus, DBCtrls,
  Grids, Outline, DBOutln, DB, DBTables, Mask, TabNotBk, About;

type
  TMainForm = class(TForm)
    SpeedBar: TPanel;
    TabbedNotebook1: TTabbedNotebook;
    Table1: TTable; { the NoteBase.DBF Database }
    Table2: TTable; { the Empl2.DB Database }
    Table3: TTable; { the Project.DB Database }
    DataSource1: TDataSource;
    DataSource2: TDataSource;
    DataSource3: TDataSource;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel5: TPanel;
    Splitter1: TPanel;
    Splitter2: TPanel;
    Splitter3: TPanel;
    DBOutline1: TDBOutline;
    DBOutline2: TDBOutline;
    DBOutline3: TDBOutline;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    EditEmpNo: TDBEdit;
    EditLastName: TDBEdit;
    EditFirstName: TDBEdit;
    EditPhoneExt: TDBEdit;
    EditHireDate: TDBEdit;
    EditSalary: TDBEdit;
    EditSupervisor: TDBEdit;
    Table2EmpNo: TIntegerField;
    Table2LastName: TStringField;
    Table2FirstName: TStringField;
    Table2PhoneExt: TStringField;
    Table2HireDate: TDateTimeField;
    Table2Salary: TFloatField;
    Table2Supervisor: TIntegerField;
    Table2FullName: TStringField;
    DBMemo1: TDBMemo;
    DBMemo2: TDBMemo;
    Status1: TPanel;
    Database1: TDatabase;
    Database2: TDatabase;
    Database3: TDatabase;
    procedure FormCreate(Sender: TObject);
    procedure ShowHint(Sender: TObject);
    procedure Table2CalcFields(DataSet: TDataset);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure Splitter1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure Splitter2DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure Splitter3DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure DBOutline2DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure DBOutline3DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure DBOutline2AutoDragDrop(Sender: TObject; var Accept: Boolean;
      var FromNode, ToNode: OpenString);
    procedure DBOutline3AutoDragDrop(Sender: TObject; var Accept: Boolean;
      var FromNode, ToNode: OpenString);
    procedure DBOutline2MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  end;

var
  MainForm: TMainForm;
  ShowHints: boolean;
implementation

{$R *.DFM}

procedure TMainForm.FormCreate(Sender: TObject);
begin
  Application.OnHint := ShowHint;
  Application.HelpFile := 'TDBOutli.hlp';
  Application.ShowHint := false;
  Table1.Open;
  Table2.Open;
  Table3.Open;
  DBOutline1.LoadFromDataSet; { this single method performs the load }
  DBOutline2.LoadFromDataSet; { of hierarchical data into the outline}
  DBOutline3.LoadFromDataSet;
end;

procedure TMainForm.ShowHint(Sender: TObject);
begin
  Status1.Caption := Application.Hint;
end;

procedure TMainForm.Table2CalcFields(DataSet: TDataset);
begin
  Table2FullName.AsString := Table2LastName.AsString + ', ' + Table2FirstName.AsString;
  { this calculated field is used as property DataFieldDisplay in the
    Employees example }
end;

procedure TMainForm.SpeedButton1Click(Sender: TObject);
begin
  AboutBox.ShowModal;
end;

procedure TMainForm.SpeedButton2Click(Sender: TObject);
begin
    Application.HelpCommand(HELP_CONTENTS, 0);
end;

{ Splitter code not related to use of TDBOutline - for Demo program only }
procedure TMainForm.Splitter1DragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
if Source = Splitter1 then
  begin
    Accept := True;
    DBOutline1.Width := X + (Sender as TControl).Left;
  end;
end;
procedure TMainForm.Splitter2DragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
if Source = Splitter2 then
  begin
    Accept := true;
    DBOutline2.Width := X + (Sender as TControl).Left;
  end;
end;
procedure TMainForm.Splitter3DragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
if Source = Splitter3 then
  begin
    Accept := True;
    DBOutline3.Height := Y + (Sender as TControl).Top;
  end;
end;

procedure TMainForm.DBOutline2DragDrop(Sender, Source: TObject; X,
  Y: Integer);
begin
  if Source = DBOutline2 then
    DBOutline2.AutoDrop(x, y); { AutoDrop is the single method call
    required to perform the move of the node and update the database }
  end;

procedure TMainForm.DBOutline3DragDrop(Sender, Source: TObject; X,
  Y: Integer);
begin
  if Source = DBOutline3 then
    DBOutline3.AutoDrop(x, y); { AutoDrop is the single method call
    required to perform the move of the node and update the database }
end;

procedure TMainForm.DBOutline3AutoDragDrop(Sender: TObject;
  var Accept: Boolean; var FromNode, ToNode: OpenString);
begin
  Accept := True; { this line overrides the default confirmation message
  presented when a node is dragged-and-dropped. This ability gives the programmer control over
  the confirmation message presented to the user}
end;

procedure TMainForm.DBOutline2AutoDragDrop(Sender: TObject;
  var Accept: Boolean; var FromNode, ToNode: OpenString);
var
  Text: string;
begin
  Text := 'This is a custom message defined in the OnAutoDragDrop event of TDBOutline.';
  if MessageDlg(Text + ' Have employee ['+NodeFrom+'] report to ['+NodeTo+ ']?',mtConfirmation,
         mbOkCancel,0) = mrOk then Accept := true
  else Accept := false { this code overrides the default confirmation
  message presented when a node is dragged-and-dropped, replacing it with
  the custom message. This ability gives the programmer control over
  the confirmation message presented to the user}
end;

procedure TMainForm.DBOutline2MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if DBOutline2.SynchSuccess then  {SynchSuccess is a read-only runtime
  property of TDBOutline -- if true, the database pointer was successfully
  synchronized with the selected node.  If false, it was not successfully
  synchronized.  In this example it is used to hide the TDBEdit fields if
  the MasterParent node is selected (the MasterParent not having a
  corresponding record in the database) }
  begin
    EditEmpNo.Visible := true;
    EditLastName.Visible := true;
    EditFirstName.Visible := true;
    EditPhoneExt.Visible := true;
    EditHireDate.Visible := true;
    EditSalary.Visible := true;
    EditSupervisor.Visible := true;
    Label1.Visible := true;
    Label2.Visible := true;
    Label3.Visible := true;
    Label4.Visible := true;
    Label5.Visible := true;
    Label6.Visible := true;
    Label7.Visible := true;
  end
  else
  begin
    EditEmpNo.Visible := false;
    EditLastName.Visible := false;
    EditFirstName.Visible := false;
    EditPhoneExt.Visible := false;
    EditHireDate.Visible := false;
    EditSalary.Visible := false;
    EditSupervisor.Visible := false;
    Label1.Visible := false;
    Label2.Visible := false;
    Label3.Visible := false;
    Label4.Visible := false;
    Label5.Visible := false;
    Label6.Visible := false;
    Label7.Visible := false;
  end;
end;

end.
